/*
  show the bits per second in the stream
  Copyright (C) 1999  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#ifndef __GUIBPSDEVICE_H
#define __GUIBPSDEVICE_H

#include <qpainter.h>
#include <qpushbt.h>
#include <qlayout.h>
#include <qslider.h>


#include <yafcore/buffer.h>

#include <guiDevice.h>
#include <song.h>


class GuiBPSDevice : public GuiDevice {
  Q_OBJECT

   Song* currentSong;

 public:
  GuiBPSDevice( QWidget *parent=0, const char *name=0 );
  ~GuiBPSDevice();

  void setSong(Song* song);
  Song* getSong();

  int getBPS();

  QSize sizeHint () const;
  void paintEvent ( QPaintEvent * paintEvent );

 signals:
  void setSongEvent();

 protected:
  void processEvent(char eventId);

};


#endif
