/*
  stores h/m/s
  Copyright (C) 1999  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#include "timeCode.h"



TimeCode::TimeCode() {
  tc_hours=0;
  tc_minutes=0;
  tc_seconds=0;
}


TimeCode::~TimeCode() {

}



int TimeCode::getHour() {
  return tc_hours;
}


void TimeCode::setHour(int hour) {
  this->tc_hours=hour;
}



int TimeCode::getMinute() {
  return tc_minutes;
}


void TimeCode::setMinute(int minute) {
  this->tc_minutes=minute;
}



int TimeCode::getSeconds() {
  return tc_seconds;
}


void TimeCode::setSeconds(int second) {
  this->tc_seconds=second;
}


void TimeCode::substract(TimeCode* a,TimeCode* b) {
  setHour(a->getHour()-b->getHour());
  setMinute(a->getMinute()-b->getMinute());
  setSeconds(a->getSeconds()-b->getSeconds());

  if (tc_seconds < 0) {
    tc_seconds=60-tc_seconds;
    tc_minutes--;
  }
  if (tc_minutes < 0) {
    tc_minutes=60+tc_minutes;
    tc_hours--;
  }
 
}


void TimeCode::copyTo(TimeCode* dest) {
  dest->setHour(getHour());
  dest->setMinute(getMinute());
  dest->setSeconds(getSeconds());
 
}


void TimeCode::print(char* name) {
  cout <<name<<" H:"<<getHour()<<" M:"<<getMinute()<<" S:"<<getSeconds()<<endl;
}
