/*
  generic audiodevice
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#ifndef __AUDIODEVICE_H
#define __AUDIODEVICE_H


#include <devices/outputDevice.h>
#include <devices/nativeMixerDevice.h>
#include <audio/audioWrapper.h>

extern "C" {
#include <stdio.h>
	   }

#define _DEFAULT_AUDIO_BUFFERSIZE 4096


#define _AUDIODEVICE_CLOSE_REQUEST      1
#define _AUDIODEVICE_CANNOT_OPEN        2


class AudioDevice :public OutputDevice {

  AudioWrapper* audioWrapper;
  AudioInfo* audioInfo;
  StatusInfo* statusInfo;
  NativeMixerDevice* nativeMixerDevice;
  int lneedInit;
  int lAutoInit;
  int lEnabled;

 public:
  AudioDevice(const char* device);
  ~AudioDevice();

  int getEnabled();
  void setEnabled(int lEnable);


  int open();
  int close();
  int isOpen();
  
  int init(int sampleSize,int speed,int stereo);

  int getAutoInit();
  void setAutoInit(int lAutoInit);

  StatusInfo* getStatusInfo();
  char* getNodeName();
  
  void writeIn(NodeDevice* source,DeviceConfig* buf);
  // Special functions for device
  
  int rawWrite(char* buf,int len);

 private:
   int init(int lForceSet);
  
};

#endif
  
  
